﻿/*
 * Készítette a SharpDevelop.
 * Felhasználó: phil
 * Dátum: 2009.12.03.
 * Idő: 14:28
 * 
 * A sablon megváltoztatásához használja az Eszközök | Beállítások | Kódolás | Szabvány Fejlécek Szerkesztését.
 */
using System;
using System.Collections;
using System.Collections.Generic;

namespace Noise.DataAcquisition
{
	/// <summary>
	/// A class to distribute channel data between several reader IChannelDataSockets (eg for plotting and logging into file).
	/// </summary>
	public class ChannelDataPipe : List<IChannelDataSocket<double>>, IChannelDataSocket<double>
	{
		protected object syncRoot;
		protected double currentValue;
		
		public ChannelDataPipe() : base()
		{
			syncRoot = (this as ICollection).SyncRoot;
		}
		
		public object SyncRoot {
			get { return syncRoot; }
		}
		
		public ChannelInfo ChannelInfo {
			get {
				if (this.Count < 1) return null;
				return this[0].ChannelInfo;
			}
		}
		
		int IChannelDataSocket<double>.Count {
			get {
				if (this.Count < 1) return 0;
				return this[0].Count;
			}
		}
		
		public double CurrentValue {
			get { return currentValue; }
		}
		
		
		public double Dequeue()
		{
			throw new NotImplementedException();
		}
		
		public void Enqueue(double item)
		{
			currentValue = item;
			foreach (IChannelDataSocket<double> channelDataSocket in this) {
				lock (channelDataSocket.SyncRoot) {
					channelDataSocket.Enqueue(item);
				}
			}
		}
		
	}
}
